<template lang="pug">

mixin ParamList
  BaseParamList.col-12.col-sm-6.col-lg-4&attributes(attributes)
    if block
      block

mixin Param
  BaseParamInput.col-12.col-sm-6.col-lg-4&attributes(attributes)
    if block
      block

BaseCollapsible(ref='collapsible' :expand='!!zspExpanded')
  template(v-slot:header='collapsible')
    .row
      .col-6.col-md-3
        strong #[i.fa.fa-filter] Zero Suppression
      BaseAnimationBlock(anim='fade')
        .col-6(v-if='!collapsible.isExpanded && zsp') {{ getModeText(activeZsp.mode) }}
  .col-12(v-if='isLoading')
    i.fa.fa-spinner.fa-pulse
  .col-12(v-else)
    .row(v-if="zsp")
      +ParamList(v-if='zsp' ref='mode' title='mode'
                 :options='$options.modes' :inEdit='inEdit' :value='zsp.mode'
                 @edit='setMode($event)')
      +ParamList(v-if='activeZsp.mode === ZSPMode.SINGLE_MASTER' title='master'
                 :value='firstMaster' :options='masterChoiceList' :inEdit='inEdit'
                 @edit='setSingleMaster($event)')
      .col-12.mt-1(v-if='activeZsp.mode === ZSPMode.MASTER')
        .row.my-3.py-2.border.border-primary.bg-light.rounded(v-for='masterId in activeZsp.master')
          +Param(value='master' :key='masterId' :title='getChanName(masterId)'
                 :readonly='true' :inEdit='inEdit')
            template(v-slot:title)
              strong {{ getChanName(masterId) }}
              span.small.ml-1 {{ getChanInfo(masterId) }}
          +ParamList(v-for='chanId in getSlaves(masterId)'
                     :key='chanId' :title='getChanName(chanId)' :value='masterId'
                     :options='masterChoiceList' :inEdit='inEdit'
                     @edit='moveSlave(chanId, $event)')
            template(v-slot:title)
              strong {{ getChanName(chanId) }}
              span.small.ml-1 {{ getChanInfo(chanId) }}
        .row.my-1.py-1.shadow.rounded(v-if='!$butils.isEmpty(activeZsp.independent)')
          .col-12
            strong Independent
          +ParamList(v-for='chanId in activeZsp.independent' value=''
                     :key='chanId' :title='getChanName(chanId)'
                     :options='filteredMasterChoice(chanId)' :inEdit='inEdit'
                     @edit='moveSlave(chanId, $event)')
            template(v-slot:title)
              strong {{ getChanName(chanId) }}
              span.small.ml-1 {{ getChanInfo(chanId) }}
</template>
<script>

export { default } from './ZeroSuppression.vue.js';

</script>
